'use strict';

const authorize = require('../auth/authorize');
const { getResponse, getErrorResponse } = require('../utils/responses');
const { getObservationRounds } = require('../db/database');
const { sortObservations } = require('../utils/sort');


module.exports = (event, context, callback) => {
    const get = () => {
        getObservationRounds().then((res) => {
            const sorted = sortObservations(res);
            callback(null, getResponse(sorted));
        }).catch((error) => {
            callback(null, getErrorResponse());
        });
    };

    authorize(event, context, callback, get);
};