'use strict';

const authorize = require('../auth/authorize');
const { getResponse, getErrorResponse } = require('../utils/responses');
const { getObservationRounds } = require('../db/database');
const { getStatistics } = require('../utils/statistics');


module.exports = (event, context, callback) => {
    const all = () => {
        getObservationRounds().then((observationRounds) => {
            let statistics = {};
            for(let i = 0; i < observationRounds.length; i++) {
                const observation = observationRounds[i];
                const statisticObject = getStatistics(observation)
                statistics[observation.id] = statisticObject
            }
            callback(null, getResponse(statistics));
        }).catch((error) => {
            callback(null, getErrorResponse());
        });
    };

    authorize(event, context, callback, all);
};
