'use strict';

const authorize = require('../auth/authorize');
const { getObservationRound } = require('../db/database');
const { getResponse, getErrorResponse } = require('../utils/responses');
const { getStatistics } = require('../utils/statistics');


module.exports = (event, context, callback) => {
    const id = event.pathParameters.id;

    const observations = () => {
        getObservationRound(id).then((res) => {
            callback(null, getResponse(getStatistics(res)));
        }).catch((error) => {
            console.error(error);
            if (error === 'unknown') {
                callback(null, getErrorResponse());
            } else {
                callback(null, getErrorResponse('Invalid observation round id!', 400));
            }
        });
    };

    authorize(event, context, callback, observations);
};
