'use strict';

function getResponse(body = {nothing: 'nothing'}, statusCode = 200) {
    return {
        statusCode: statusCode,
        body: JSON.stringify(body),
        headers: {
            "Access-Control-Allow-Origin": "*"
        }
    };
}

function getErrorResponse(message = 'Internal server error', statusCode = 500) {
    return {
        statusCode: statusCode,
        body: JSON.stringify({
            error:  message
        }),
        headers: {
            "Access-Control-Allow-Origin": "*"
        }
    };
}

module.exports = {
    getResponse,
    getErrorResponse
};