'use strict';

function containsKey(obj, key) {
    return (key in obj);
}

function getFormattedMissingParameterString(s) {
    if (s.length === 0) {
        return s;
    }
    return 'Invalid request body. Missing parameters: ' + s.slice(0, s.length-2) + '.';
}

function getMissingParameters(data, requiredKeys) {
    const missingParameters = [];
    for (let i = 0; i < requiredKeys.length; i++) {
        const key = requiredKeys[i];
        if (!containsKey(data, key)) {
            //missingParameters += key + ', ';
            missingParameters.push(key);
        }
    }
    return missingParameters;
}

function getMissingParametersErrorMessage(parameters) {
    if (parameters.length === 0) {
        return '';
    }

    let parameterString = '';
    for (let i = 0; i < parameters.length; i++) {
        parameterString += parameters[i] + ', ';
    }

    return 'Invalid JSON input. Missing parameters: ' + parameterString.slice(0, parameterString.length-2) + '.';
}

module.exports = {
    getMissingParameters,
    getMissingParametersErrorMessage
};