function isType(value, type) {
    switch (type) {
        case 'int':
            return Number.isInteger(value);
        case 'coordinate':
            return isCoordinate(value);
        case 'userTrackingPoints':
            return isUserTrackingPoints(value);
    }
    return typeof value === type;
}

function listIsValid (list) {
    for (let i = 0; i < list.length; i++) {
        if (list[i] === false) {
            return false;
        }
    }
    return true;
}

function isCoordinate(obj) {
    return 'latitude' in obj && 'longitude' in obj;
}

function isUserTrackingPoints(trackingPoints) {
    if (!Array.isArray(trackingPoints)) {
        return false;
    }
    for (let i = 0; i < trackingPoints.length; i++) {
        const point = trackingPoints[i];
        if (!isValidUserTrackingPoint(point)) {
            return false;
        }
    }
    return true;
}

function isValidUserTrackingPoint(point) {
    return Array.isArray(point)
        && point.length === 2
        && isNumber(point[0])
        && isNumber(point[1]);
}

function isNumber(n) {
    return typeof n === 'number'
}

module.exports = {
    isType,
    listIsValid
};