import * as types from '../constants/actionTypes/observationFormActionTypes';
import { getInitData } from '../utilities/selectCategoryHelper';


export function setCategoryExpanded(expanded) {
  return {
    type: types.SET_CATEGORY_EXPANDED,
    expanded
  };
}

export function setNewObservationFormCategory(category) {
  return {
    type: types.SET_NEW_OBSERVATION_FORM_CATEGORY,
    category
  };
}

export function setDescription(description) {
  return {
    type: types.SET_NEW_OBSERVATION_FORM_DESCRIPTION,
    description
  };
}

export function addImage(image) {
  return {
    type: types.ADD_IMAGE,
    image
  };
}


export function deleteFormImage(index) {
  return {
    type: types.DELETE_FORM_IMAGE,
    index
  };
}

export function setImages(images) {
  return {
    type: types.SET_IMAGES,
    images
  };
}

// NEW
export function setCategory(category) {
  return {
    type: types.SET_CATEGORY,
    category
  };
}

export function setCurrentPanel(index) {
  return {
    type: types.SET_CURRENT_PANEL,
    index
  };
}

export function incrementDisplayIndex() {
  return {
    type: types.INCREMENT_DISPLAY_INDEX
  };
}

export function setDisplayIndex(displayIndex) {
  return {
    type: types.SET_DISPLAY_INDEX,
    displayIndex
  };
}

export function incrementIndex() {
  return {
    type: types.INCREMENT_INDEX
  };
}

export function setIndex(index) {
  return {
    type: types.SET_INDEX,
    index
  };
}

export function setData(category) {
  const data = JSON.parse(JSON.stringify(getInitData(category)));
  return {
    type: types.SET_DATA,
    data
  };
}

export function setFormState(formState) {
  return {
    type: types.SET_FORM_STATE,
    formState
  };
}

export function updateDataField(field, value) {
  return {
    type: types.UPDATE_DATA_FIELD,
    field,
    value
  };
}

export function updateEwe(ewes) {
  return {
    type: types.UPDATE_EWES,
    ewes
  };
}

export function updateLamb(lamb) {
  return {
    type: types.UPDATE_LAMB,
    lamb
  };
}

export function updateGroup(index, sheepType, data) {
  return {
    type: types.UPDATE_SHEEP_GROUP,
    index,
    sheepType,
    data
  };
}

export function addSheepGroup() {
  return {
    type: types.ADD_SHEEP_GROUP
  };
}

export function subtractSheepGroup() {
  return {
    type: types.SUBTRACT_SHEEP_GROUP
  };
}

export function setFormStructure(formStructure) {
  return {
    type: types.SET_FORM_STRUCTURE,
    formStructure
  };
}

export function resetForm() {
  return {
    type: types.RESET_FORM
  };
}
