import * as types from 'src/constants/observationRoundTypes.js';

export function saveObservationRoundMetadata(data) {
  return {
    type: types.SAVE_OBSERVATION_ROUND_METADATA,
    data
  };
}

export function addUserTrackingPoint(trackingPoint) {
  return {
    type: types.ADD_USER_TRACKING_POINT,
    trackingPoint
  };
}

export function addNewRegistrationPoint(id, coordinates) {
  const registrationPoint = {
    ...coordinates,
    observations: {},
    childrenIsVisible: true
  };
  return {
    type: types.ADD_NEW_REGISTRATION_POINT,
    registrationPoint,
    id
  };
}

const initialObservationData = {
  type: '',
  images: [],
  groups: []
};

export function addNewObservation(parentId, id, position, data = initialObservationData) {
  return {
    type: types.ADD_NEW_OBSERVATION,
    parentId,
    id,
    latitude: position.latitude,
    longitude: position.longitude,
    data
  };
}

export function updateObservationData(registrationPointId, observationId, data) {
  return {
    type: types.UPDATE_OBSERVATION_DATA,
    registrationPointId,
    observationId,
    data
  };
}


export function toggleChildrenVisibility(id) {
  return {
    type: types.TOGGLE_CHILDREN_VISIBILITY,
    id
  };
}

export function registerHomePosition(position) {
  return {
    type: types.REGISTER_HOME_POSITION,
    position
  };
}

export function deleteObservation(observationId, registrationPointId) {
  return {
    type: types.DELETE_OBSERVATION,
    observation: {
      observationId,
      registrationPointId
    }
  };
}

export function updateObservation(registrationPointId, observationId, observation) {
  return {
    type: types.UPDATE_OBSERVATION,
    registrationPointId,
    observationId,
    observation
  };
}

export function updateState(state) {
  return {
    type: types.SET_STATE,
    state
  };
}

export function deleteImage(observation, index) {
  return {
    type: types.DELETE_IMAGE,
    index,
    observation
  };
}

export function resetObservationRoundData() {
  return {
    type: types.RESET_OBSERVATION_DATA
  };
}

export function finishRound() {
  return {
    type: types.FINISH_ROUND
  };
}

export function roundHasBeenUploaded() {
  return {
    type: types.ROUND_HAS_BEEN_UPLOADED
  };
}
