import React, { Component } from 'react';
import PropTypes from 'prop-types';

class Button extends Component {
  constructor(props) {
    super(props);
    this.click = this.click.bind(this);
  }

  click(event) {
    event.preventDefault();
    this.props.onClick();
  }

  render() {
    const { className, label } = this.props;
    return (
      <button
        className={className}
        onClick={this.click}
      >
        {label}
      </button>
    );
  }
}

Button.defaultProps = {
  className: ''
};

if (__DEV__) {
  Button.propTypes = {
    className: PropTypes.string,
    label: PropTypes.string.isRequired,
    onClick: PropTypes.func.isRequired
  };
}

export default Button;
