/* eslint-disable jsx-a11y/no-static-element-interactions */
import PropTypes from 'prop-types';
import React, { Component } from 'react';

class NavigationBar extends Component {
  constructor(props) {
    super(props);
    this.onClick = this.onClick.bind(this);
  }

  onClick(event) {
    event.preventDefault();
    this.props.onClick();
  }

  render() {
    const { label } = this.props;
    return (
      <ul className={`navigation-bar${this.props.showBackArrow ? '' : ' hide-arrow'}`}>
        <li
          className="back-arrow"
          onClick={this.onClick}
        >
          <img className="back-arrow-image" src="img/vectors/left-arrow.svg" />
        </li>
        <li className="label-container">
          {label}
        </li>
      </ul>
    );
  }
}

NavigationBar.defaultProps = {
  label: '',
  onClick: () => {},
  showBackArrow: true
};

if (__DEV__) {
  NavigationBar.propTypes = {
    label: PropTypes.string,
    onClick: PropTypes.func,
    showBackArrow: PropTypes.bool
  };
}

export default NavigationBar;
