/* eslint-disable react/forbid-prop-types */
import React, { Component } from 'react';
import PropTypes from 'prop-types';

class NumberPicker extends Component {
  constructor(props) {
    super(props);
    this.decrement = this.decrement.bind(this);
    this.increment = this.increment.bind(this);
  }

  decrement(event) {
    event.preventDefault();
    const { value, bounds } = this.props;
    const lowerBound = bounds[0];
    const newValue = value > lowerBound + 1 ? value - 1 : lowerBound;
    this.props.onChange(newValue, this.props.name);
  }

  increment(event) {
    event.preventDefault();
    const { value, bounds } = this.props;
    const upperBound = bounds[1];
    const newValue = value < upperBound ? value + 1 : upperBound;
    this.props.onChange(newValue, this.props.name);
  }

  render() {
    const { value } = this.props;
    return (
      <div className="number-picker-container">
        <button
          className="btn btn-white btn-circle"
          onClick={this.decrement}
        ><i className="fa fa-minus fa-fw" /></button>
        <span className="number-picker-value">{value}</span>
        <button
          className="btn btn-white btn-circle"
          onClick={this.increment}
        ><i className="fa fa-plus fa-fw" /></button>
      </div>
    );
  }
}

NumberPicker.defaultProps = {
  bounds: [0, 100],
  name: ''
};

if (__DEV__) {
  NumberPicker.propTypes = {
    value: PropTypes.number.isRequired,
    onChange: PropTypes.func.isRequired,
    bounds: PropTypes.array,
    name: PropTypes.string
  };
}

export default NumberPicker;
