import React, { Component } from 'react';

class StatisticContainer extends Component {

  constructor(props) {
    super(props);

    this.getIcon = this.getIcon.bind(this);
  }

  getIcon() {
    if (this.props.imagePath !== '') {
      return <img className={`image${this.props.bigger ? ' bigger' : ''}`} src={this.props.imagePath} alt="icon" />;
    }
    return <i className={`icon ${this.props.iconClass}`} />;
  }

  render() {
    return (
      <div className="statistic-container">
        <div className="icon-container">
          { this.getIcon() }
        </div>
        <div className="icon-text">{this.props.value}</div>
      </div>
    );
  }
}

StatisticContainer.defaultProps = {
  bigger: true,
  imagePath: ''
};

export default StatisticContainer;
