import { ALTERNATIVES, TEXT_FIELD } from './formElementtTypes';
import { sheepColors } from './sheepColors';
import sheepTypes from './sheepTypes';
import { baseUrl } from './NewObservationCategories';

const causeOfDeathOptions = [
  'Jervangrep',
  'Ulveangrep',
  'Bjørneangrep',
  'Sykdom',
  'Fall',
  'Ukjent'
];

const timeOfDeath = [
  '< 1 uke siden',
  '> 1 uke siden'
];

const covered = [
  'Ja',
  'Nei',
  'Delvis',
  'Ja - med kvist',
  'Ja - med stein og torv'
];

export const deadSheepFormStructure = {
  hasCategories: false,
  elements: [
    {
      heading: 'Type sau',
      formInfo: {
        type: ALTERNATIVES,
        alternatives: sheepTypes,
        field: 'sheepType',
        key: 'subcategoryDeadSheep',
        icons: {
          [sheepTypes[0]]: `${baseUrl}ewe`,
          [sheepTypes[1]]: `${baseUrl}lamb`,
          [sheepTypes[2]]: `${baseUrl}unknown`
        }
      }
    },
    {
      heading: 'Farge',
      formInfo: {
        type: ALTERNATIVES,
        alternatives: sheepColors,
        field: 'color'
      }
    },
    {
      heading: 'Dødsårsak',
      formInfo: {
        type: ALTERNATIVES,
        alternatives: causeOfDeathOptions,
        field: 'causeOfDeath'
      }
    },
    {
      heading: 'Dødstidspunkt',
      formInfo: {
        type: ALTERNATIVES,
        alternatives: timeOfDeath,
        field: 'timeOfDeath'
      }
    },
    {
      heading: 'Tildekt',
      formInfo: {
        type: ALTERNATIVES,
        alternatives: covered,
        field: 'covered'
      }
    },
    {
      heading: 'Kontaktet',
      formInfo: {
        type: TEXT_FIELD,
        field: 'contacted'
      }
    }
  ]
};