import { ALTERNATIVES, TEXT_FIELD } from './formElementtTypes';
import { baseUrl } from './NewObservationCategories';

const categories = [
  'Hund alene',
  'Hund med eier'
];

const dogColors = [
  'Brun',
  'Grå',
  'Hvit',
  'Svart',
  'Spettete svart og grå',
  'Hvit og svart',
  'Hvit og brun',
  'Svart og brun',
  'Svart og grå',
  'Brun og svart',
  'Brun og hvit',
];

const dogBreeds = [
  'Jakthund',
  'Fuglehund',
  'Harehund',
  'Sauehund',
  'Trekkhund',
  'Annet'
];

const furTypes = [
  'Ukjent',
  'Kort',
  'Halvlang',
  'Lang'
];

const dogCollars = [
  'Ingen',
  'Halsbånd',
  'Halsbånd med antenne'
];

const ownerGenders = [
  'Mann',
  'Kvinne',
  'Ukjent'
];

const ownerAge = [
  'Ukjent',
  'Under 20',
  '20-30',
  '30-50',
  'Over 50'
];

const ownerPantsColors = [
  'Brun',
  'Grønn',
  'Blå',
  'Svart',
  'Annet'
];

const ownerTopColors = [
  'Brun',
  'Grønn',
  'Blå',
  'Lys',
  'Gul',
  'Annet'
];

const ownerHairColor = [
  'Ukjent',
  'Lys',
  'Mørk'
];

const ownerGun = [
  'Ingen våpen',
  'Rifle',
  'Hagle',
  'Rifle og hagle'
];

const otherPersons = [
  'Ingen',
  '1 kvinne',
  '1 mann',
  '2 personer',
  'Flere personer'
];


const ownerBackpackSize = [
  'Ingen sekk',
  '5-15 liter',
  '15-50 liter',
  'Større'
];

export const dogFormStructure = {
  elements: [
    {
      heading: 'Kategori',
      formInfo: {
        type: ALTERNATIVES,
        alternatives: categories,
        field: 'category',
        icons: {
          [categories[0]]: `${baseUrl}dog`,
          [categories[1]]: `${baseUrl}dog_with_owner`
        }
      },
      subcategories: {
        [categories[0]]: [
          {
            heading: 'Farge',
            formInfo: {
              type: ALTERNATIVES,
              alternatives: dogColors,
              field: 'dogColor'
            }
          },
          {
            heading: 'Hunderase',
            formInfo: {
              type: ALTERNATIVES,
              alternatives: dogBreeds,
              field: 'breed'
            }
          },
          {
            heading: 'Pelstype',
            formInfo: {
              type: ALTERNATIVES,
              alternatives: furTypes,
              field: 'furType'
            }
          },
          {
            heading: 'Halsbånd',
            formInfo: {
              type: ALTERNATIVES,
              alternatives: dogCollars,
              field: 'collar'
            }
          }
        ],
        [categories[1]]: [
          {
            heading: 'Farge',
            formInfo: {
              type: ALTERNATIVES,
              alternatives: dogColors,
              field: 'dogColor'
            }
          },
          {
            heading: 'Hunderase',
            formInfo: {
              type: ALTERNATIVES,
              alternatives: dogBreeds,
              field: 'breed'
            }
          },
          {
            heading: 'Pelstype',
            formInfo: {
              type: ALTERNATIVES,
              alternatives: furTypes,
              field: 'furType'
            }
          },
          {
            heading: 'Halsbånd',
            formInfo: {
              type: ALTERNATIVES,
              alternatives: dogCollars,
              field: 'collar'
            }
          },
          {
            heading: 'Navn på eier',
            formInfo: {
              type: TEXT_FIELD,
              field: 'ownerName'
            }
          },
          {
            heading: 'Kjønn på eier',
            formInfo: {
              type: ALTERNATIVES,
              alternatives: ownerGenders,
              field: 'ownerGender'
            }
          },
          {
            heading: 'Alder på eier',
            formInfo: {
              type: ALTERNATIVES,
              alternatives: ownerAge,
              field: 'ownerAge'
            }
          },
          {
            heading: 'Buksefarge',
            formInfo: {
              type: ALTERNATIVES,
              alternatives: ownerPantsColors,
              field: 'pantsColor'
            }
          },
          {
            heading: 'Farge på overdel',
            formInfo: {
              type: ALTERNATIVES,
              alternatives: ownerTopColors,
              field: 'jacketColor'
            }
          },
          {
            heading: 'Hårfarge på eier',
            formInfo: {
              type: ALTERNATIVES,
              alternatives: ownerHairColor,
              field: 'ownerHairColor'
            }
          },
          {
            heading: 'Våpen',
            formInfo: {
              type: ALTERNATIVES,
              alternatives: ownerGun,
              field: 'gun'
            }
          },
          {
            heading: 'Andre personer',
            formInfo: {
              type: ALTERNATIVES,
              alternatives: otherPersons,
              field: 'otherPersons'
            }
          },
          {
            heading: 'Størrelse på sekk',
            formInfo: {
              type: ALTERNATIVES,
              alternatives: ownerBackpackSize,
              field: 'backpackSize'
            }
          }
        ]
      }
    }
  ]


};
