import { ALTERNATIVES, TEXT_FIELD } from './formElementtTypes';
import { sheepColors } from './sheepColors';
import sheepTypes from './sheepTypes';
import { baseUrl } from './NewObservationCategories';

const categories = [
  'Halter',
  'Hodeskade',
  'Kroppskade',
  'Blødning',
  'Annet'
];

const decisions = [
  'La leve, ta med hjem',
  'Avliv, ta med hjem',
  'Avliv, dekk til',
  'Etterlat',
  'Avventer beslutning'
];

const shouldBeCounted = [
  'Ja',
  'Nei'
];

const injuries = {
  Halter: [
    'Høyre bakfot',
    'Venstre bakfot',
    'Bagge bakføtter',
    'Høyre frontfot',
    'Venstre frontfot'
  ],
  Hodeskade: [
    'Høyre side',
    'Venstre side',
    'Begge sider'
  ],
  Kroppskade: [
    'Høyre side',
    'Venstre side',
    'Begge sider'
  ],
  Blødning: [
    'Høyre side',
    'Venstre side',
    'Begge sider',
    'Hodet'
  ]
};

export const injuredSheepFormStructure = {
  hasCategories: false,
  elements: [{
    heading: 'Kategori',
    formInfo: {
      key: 'subcategoryInjuredSheep',
      type: ALTERNATIVES,
      alternatives: categories,
      field: 'category'
    },
    subcategories: {
      [categories[0]]: [
        {
          heading: 'Har denne sauen blitt registrert tidligere i løpet av runden?',
          formInfo: {
            type: ALTERNATIVES,
            alternatives: shouldBeCounted,
            field: 'shouldBeCounted'
          }
        },
        {
          heading: 'Skade',
          formInfo: {
            type: ALTERNATIVES,
            alternatives: injuries[[categories[0]]],
            field: 'injury'
          }
        },
        {
          heading: 'Type sau',
          formInfo: {
            type: ALTERNATIVES,
            alternatives: sheepTypes,
            field: 'sheepType',
            icons: {
              [sheepTypes[0]]: `${baseUrl}ewe`,
              [sheepTypes[1]]: `${baseUrl}lamb`,
              [sheepTypes[2]]: `${baseUrl}unknown`
            }
          }
        },
        {
          heading: 'Farge',
          formInfo: {
            type: ALTERNATIVES,
            alternatives: sheepColors,
            field: 'color'
          }
        },
        {
          heading: 'Avgjørelse',
          formInfo: {
            type: ALTERNATIVES,
            alternatives: decisions,
            field: 'decision'
          }
        },
        {
          heading: 'Kontaktet',
          formInfo: {
            type: TEXT_FIELD,
            field: 'contacted'
          }
        }
      ],
      [categories[1]]: [
        {
          heading: 'Har denne sauen blitt registrert tidligere i løpet av runden?',
          formInfo: {
            type: ALTERNATIVES,
            alternatives: shouldBeCounted,
            field: 'shouldBeCounted'
          }
        },
        {
          heading: 'Skade',
          formInfo: {
            type: ALTERNATIVES,
            alternatives: injuries[[categories[1]]],
            field: 'injury'
          }
        },
        {
          heading: 'Type sau',
          formInfo: {
            type: ALTERNATIVES,
            alternatives: sheepTypes,
            field: 'sheepType',
            icons: {
              [sheepTypes[0]]: `${baseUrl}ewe`,
              [sheepTypes[1]]: `${baseUrl}lamb`,
              [sheepTypes[2]]: `${baseUrl}unknown`
            }
          }
        },
        {
          heading: 'Farge',
          formInfo: {
            type: ALTERNATIVES,
            alternatives: sheepColors,
            field: 'color'
          }
        },
        {
          heading: 'Avgjørelse',
          formInfo: {
            type: ALTERNATIVES,
            alternatives: decisions,
            field: 'decision'
          }
        },
        {
          heading: 'Kontaktet',
          formInfo: {
            type: TEXT_FIELD,
            field: 'contacted'
          }
        }
      ],
      [categories[2]]: [
        {
          heading: 'Har denne sauen blitt registrert tidligere i løpet av runden?',
          formInfo: {
            type: ALTERNATIVES,
            alternatives: shouldBeCounted,
            field: 'shouldBeCounted'
          }
        },
        {
          heading: 'Skade',
          formInfo: {
            type: ALTERNATIVES,
            alternatives: injuries[[categories[2]]],
            field: 'injury'
          }
        },
        {
          heading: 'Type sau',
          formInfo: {
            type: ALTERNATIVES,
            alternatives: sheepTypes,
            field: 'sheepType',
            icons: {
              [sheepTypes[0]]: `${baseUrl}ewe`,
              [sheepTypes[1]]: `${baseUrl}lamb`,
              [sheepTypes[2]]: `${baseUrl}unknown`
            }
          }
        },
        {
          heading: 'Farge',
          formInfo: {
            type: ALTERNATIVES,
            alternatives: sheepColors,
            field: 'color'
          }
        },
        {
          heading: 'Avgjørelse',
          formInfo: {
            type: ALTERNATIVES,
            alternatives: decisions,
            field: 'decision'
          }
        },
        {
          heading: 'Kontaktet',
          formInfo: {
            type: TEXT_FIELD,
            field: 'contacted'
          }
        }
      ],
      [categories[3]]: [
        {
          heading: 'Har denne sauen blitt registrert tidligere i løpet av runden?',
          formInfo: {
            type: ALTERNATIVES,
            alternatives: shouldBeCounted,
            field: 'shouldBeCounted'
          }
        },
        {
          heading: 'Skade',
          formInfo: {
            type: ALTERNATIVES,
            alternatives: injuries[[categories[3]]],
            field: 'injury'
          }
        },
        {
          heading: 'Type sau',
          formInfo: {
            type: ALTERNATIVES,
            alternatives: sheepTypes,
            field: 'sheepType',
            icons: {
              [sheepTypes[0]]: `${baseUrl}ewe`,
              [sheepTypes[1]]: `${baseUrl}lamb`,
              [sheepTypes[2]]: `${baseUrl}unknown`
            }
          }
        },
        {
          heading: 'Farge',
          formInfo: {
            type: ALTERNATIVES,
            alternatives: sheepColors,
            field: 'color'
          }
        },
        {
          heading: 'Avgjørelse',
          formInfo: {
            type: ALTERNATIVES,
            alternatives: decisions,
            field: 'decision'
          }
        },
        {
          heading: 'Kontaktet',
          formInfo: {
            type: TEXT_FIELD,
            field: 'contacted'
          }
        }
      ],
      [categories[4]]: []
    }
  }],
  categoryElement: {
    heading: 'Kategori',
    formInfo: {
      key: 'subcategoryInjuredSheep',
      type: ALTERNATIVES,
      alternatives: categories,
      field: 'category'
    }
  }
};

