import {ALTERNATIVES} from './formElementtTypes';
import {baseUrl} from './NewObservationCategories';

const categories = [
  'Rovdyr',
  'Rovfugl'
];

export const animalTypes = [
  'Jerv',
  'Bjørn',
  'Ulv',
  'Rev',
  'Gaupe',
  'Annet'
];

export const birdTypes = [
  'Kongeørn',
  'Fiskeørn',
  'Hauk',
  'Ugle',
  'Annet'
];

export const colors = [
  'Brun',
  'Svart',
  'Grå'
];

export const predatorFormStructure = {
  elements: [{
    heading: 'Rovdyr eller rovfugl',
    formInfo: {
      type: ALTERNATIVES,
      alternatives: categories,
      field: 'category',
      icons: {
        [categories[0]]: `${baseUrl}predator_ground`,
        [categories[1]]: `${baseUrl}predator_bird`
      }
    },
    subcategories: {
      [categories[0]]: {
        heading: 'Dyr',
        formInfo: {
          type: ALTERNATIVES,
          alternatives: animalTypes,
          field: 'animal'
        }
      },
      [categories[1]]: {
        heading: 'Fugl',
        formInfo: {
          type: ALTERNATIVES,
          alternatives: birdTypes,
          field: 'animal'
        }
      }
    }
  }]
};
