import { ALTERNATIVES, SHEEP_COLOR, COUNTER } from './formElementtTypes';
import { sheepColors } from './sheepColors';

export const EWE = 'Søye alene';
export const LAMB1 = 'Lam alene';
export const GROUP = '1 gruppe';
export const MULTIPLE_GROUPS = 'Flere grupper'

export const categories = [
  EWE,
  LAMB1,
  GROUP,
  MULTIPLE_GROUPS
];

export const initialState = {
  category: '',
  categoryExpanded: true,
  numberOfGroups: 2
};

const injuryCategories = [
  'Halter',
  'Hodeskade',
  'Kroppskade',
  'Blødning',
  'Annet'
];

const decisions = [
  'La leve, ta med hjem',
  'Avliv, ta med hjem',
  'Avliv, dekk til',
  'Etterlat',
  'Avventer beslutning'
];

const shouldBeCounted = [
  'Ja',
  'Nei'
];

const injuries = {
  Halter: [
    'Høyre bakfot',
    'Venstre bakfot',
    'Bagge bakføtter',
    'Høyre frontfot',
    'Venstre frontfot'
  ],
  Hodeskade: [
    'Høyre side',
    'Venstre side',
    'Begge sider'
  ],
  Kroppskade: [
    'Høyre side',
    'Venstre side',
    'Begge sider'
  ],
  Blødning: [
    'Høyre side',
    'Venstre side',
    'Begge sider',
    'Hodet'
  ]
};


// TODO: Move this?
export const getSheepGroup = (index = -1, data) => {
  if (data !== undefined) {
    let res = [];

    data.groups.forEach((element, dataElements) => {
      const e = [
        {
          heading: 'Antall søyer',
          formInfo: {
            type: SHEEP_COLOR,
            groupIndex: index,
            alternatives: sheepColors,
            field: 'ewes',
            key: 'ewes' + dataElements
          },
          key: dataElements
        },
        {
          heading: 'Antall lam',
          formInfo: {
            type: SHEEP_COLOR,
            groupIndex: dataElements,
            alternatives: sheepColors,
            field: 'lamb',
            key: 'lamb' + dataElements
          },
          key: dataElements
        }
      ];
      res = res.concat(e);
    });

    return res;
  }


  return [
    {
      heading: 'Antall søyer',
      formInfo: {
        type: SHEEP_COLOR,
        groupIndex: index,
        alternatives: sheepColors,
        field: 'ewes'
      },
      key: index
    },
    {
      heading: 'Antall lam',
      formInfo: {
        type: SHEEP_COLOR,
        groupIndex: index,
        alternatives: sheepColors,
        field: 'lamb'
      },
      key: index
    }
  ];
};

export const sheepFormStructure = {
  hasCategories: true,
  categoryElement: {
    heading: 'Underkategori',
    formInfo: {
      sheepType: 'ewe',
      type: ALTERNATIVES,
      alternatives: categories,
      key: 'subcategorySheep',
      field: 'category'
    }
  },
  [categories[0]]: [
    {
      heading: 'Farge',
      formInfo: {
        type: ALTERNATIVES,
        alternatives: sheepColors,
        field: 'color'
      }
    },
    {
      heading: 'Skade',
      formInfo: {
        type: ALTERNATIVES,
        showNextCount: 1,
        showNextTrueValue: 'Ja',
        alternatives: ['Ja', 'Nei'],
        field: 'hasInjury'
      }
    },
    {
      heading: 'Skade',
      formInfo: {
        type: ALTERNATIVES,
        alternatives: injuries[[injuryCategories[0]]],
        field: 'injuryCategory'
      }
    }
  ],
  [categories[1]]: [
    {
      heading: 'Farge',
      formInfo: {
        type: ALTERNATIVES,
        alternatives: sheepColors,
        field: 'color'
      }
    }
  ],
  [categories[2]]: [
    {
      heading: 'Antall søyer',
      formInfo: {
        type: SHEEP_COLOR,
        groupIndex: 0,
        alternatives: sheepColors,
        field: 'ewes'
      }
    },
    {
      heading: 'Antall lam',
      formInfo: {
        type: SHEEP_COLOR,
        groupIndex: 0,
        alternatives: sheepColors,
        field: 'lamb'
      }
    }
  ],
  [categories[3]]: [
    {
      heading: 'Antall grupper',
      formInfo: {
        type: COUNTER,
        alternatives: sheepColors,
        field: 'count'
      }
    }
  ]
};

