/* eslint-disable jsx-a11y/no-static-element-interactions */
import PropTypes from 'prop-types';
import React, { Component } from 'react';

class NavBar extends Component {
  constructor(props) {
    super(props);
    this.onClick = this.onClick.bind(this);
  }

  onClick(event) {
    event.preventDefault();
    this.props.onClick();
  }

  render() {
    const { label } = this.props;
    return (
      <ul className="navigation-bar">
        <li
          className="back-arrow"
          onClick={this.onClick}
        >
          <img className="back-arrow-image" src="img/vectors/left-arrow.svg" />
        </li>
        <li id="observation-info-navbar-text" className="label-container">
          {label}
        </li>
        <li className="icon-container" onClick={() => this.props.delete()}>
          <i className={`fa fa-trash${this.props.showDeleteButton ? '' : ' hide'}`} />
        </li>
      </ul>
    );
  }
}

NavBar.defaultProps = {
  label: '',
  onClick: () => {},
  showBackArrow: true
};

if (__DEV__) {
  NavBar.propTypes = {
    label: PropTypes.string,
    onClick: PropTypes.func,
    showBackArrow: PropTypes.bool
  };
}

export default NavBar;
