import React, { Component } from 'react';
import { openConfirmWindow } from '../../utilities/warning_window';

class AddButton extends Component {

  constructor(props) {
    super(props);
    this.getAlternativeText = this.getAlternativeText.bind(this);
    this.getAlternativeIcon = this.getAlternativeIcon.bind(this);
    this.onNewObservationRoundClick = this.onNewObservationRoundClick.bind(this);
  }

  onNewObservationRoundClick() {
    if (this.props.totalStorage < 1) {
      openConfirmWindow(
        'Du har ikke lastet ned noe kartområde enda. Det anbefales å laste ned relevant kartområde over wi-fi før ' +
        'man starter turen da det krever mye mobildata å laste kartet. Ønsker du å starte tilsynsturen uansett?',
        this.props.onNewObservationRoundClick
      );
    } else {
      this.props.onNewObservationRoundClick();
    }
  }

  getAlternativeText() {
    if (this.props.roundIsActive) {
      return (
        <div
          onClick={this.props.onNewObservationClick}
          className={`new-observation-text${this.props.show ? ' show' : ''}`}
        >
          Ny observasjon
        </div>
      );
    } else {
      return (
        <div
          onClick={this.onNewObservationRoundClick}
          className={`new-observation-text${this.props.show ? ' show' : ''}`}
        >
          Ny tilsynstur
        </div>
      );
    }
  }

  getAlternativeIcon() {
    if (this.props.roundIsActive) {
      return (
        <button
          onClick={this.props.onNewObservationClick}
          className={`btn btn-default new-observation-button${this.props.show ? ' show' : ''}`}
        >
          <i className="fa fa-map-marker" />
        </button>
      );
    } else {
      return (
        <button
          onClick={this.props.onNewObservationRoundClick}
          className={`btn btn-default new-observation-button${this.props.show ? ' show' : ''}`}
        >
          <i className="fa fa-map-o" />
        </button>
      );
    }
  }

  render() {
    return (
      <div className={`add-button${this.props.hideAddButton ? ' hide' : ''}`}>
        {this.getAlternativeText()}
        {this.getAlternativeIcon()}
        <button
          onClick={this.props.onAddButtonClick}
          className={`btn btn-default add-to-map-button${this.props.show ? ' red' : ''}`}
        >
          <i className="fa fa-plus" />
        </button>
      </div>
    );
  }
}

export default AddButton;
