/* eslint-disable react/require-default-props,react/forbid-prop-types,jsx-a11y/no-static-element-interactions */
import React, { Component } from 'react';
import { connect } from 'react-redux';
import { bindActionCreators } from 'redux';
import * as routerActions from '../../actions/routerActions.js';
import * as transition from '../../utilities/transitions.js';

class NavBar extends Component {

  constructor(props) {
    super(props);
    this.openMenu = this.openMenu.bind(this);
  }

  openMenu() {
    this.props.routerActions.toggleNavigationMenuView();
  }

  render() {
    return (
      <ul className="main-map-navbar">
        <li className="navbar-settings-container" onClick={this.openMenu}>
          <div className="navbar-settings-icon">
            <div />
            <div />
            <div />
          </div>
        </li>
      </ul>
    );
  }
}

function mapStateToProps(state) {
  return {
    appRouter: state.router
  };
}

function mapDispatchToProps(dispatch) {
  return {
    routerActions: bindActionCreators(routerActions, dispatch)
  };
}

export default connect(mapStateToProps, mapDispatchToProps)(NavBar);
