/* eslint-disable react/forbid-prop-types */
import PropTypes from 'prop-types';
import React, { Component } from 'react';
import {
  DEAD_SHEEP,
  DOG,
  SHEEP,
  OTHER,
  PREDATOR,
  REINDEER,
  WOOL,
  icons
} from '../../constants/observation/NewObservationCategories.js';
import { MULTIPLE_GROUPS, sheepFormStructure, getSheepGroup } from '../../constants/observation/sheep';


class CategorySelection extends Component {
  constructor(props) {
    super(props);
    this.onClick = this.onClick.bind(this);
  }

  onClick(category) {
    const { setDisplayIndex, setIndex, setCategory, setData, setFormStructure } = this.props.observationFormActions;
    setCategory(category);
    setDisplayIndex(1);
    setIndex(1);
    setData(category);
    if (category === 'Sau') {
      const formStructure = { ...sheepFormStructure };
      // const multipleGroups = formStructure[MULTIPLE_GROUPS].concat(getSheepGroup(0));
      // formStructure[MULTIPLE_GROUPS] = multipleGroups;
      // setFormStructure(formStructure);
    }
  }

  getClassName(category) {
    const className = '';
    return className + (this.props.observationForm.category === category ? ' selected' : '');
  }

  render() {
    const categories = [SHEEP, DEAD_SHEEP, WOOL, DOG, PREDATOR, REINDEER, OTHER];

    const buttons = categories.map(category => {
      const color = this.props.observationForm.category === category ? '_white.svg' : '_black.svg';
      return (
        <button
          onClick={() => {
            this.onClick(category);
          }}
          className={this.getClassName(category)}
          key={category}
        >
          <img className="category-image" src={icons[category] + color} alt="icon" />
          <div className="category-text">
            {category}
          </div>
        </button>
      );
    });
    return (
      <div className={`options ${'options-' + buttons.length}`}>
        {buttons}
      </div>
    );
  }
}

if (__DEV__) {
  CategorySelection.propTypes = {
    observationFormActions: PropTypes.object.isRequired,
    observationForm: PropTypes.object.isRequired
  };
}

export default CategorySelection;
