import React, { Component } from 'react';
import { LAZY_TOUCH_DELAY } from '../../constants/lazyTouch';

class NextButton extends Component {
  constructor(props) {
    super(props);
    this.onClick = this.onClick.bind(this);
    this.state = {
      isClickable: false
    };
  }

  componentDidMount() {
    const enableButton = () => {
      this.setState({
        isClickable: true
      });
    };
    setTimeout(enableButton, LAZY_TOUCH_DELAY);
  }

  onClick() {
    if (this.state.isClickable) {
      this.props.onClick();
    }
  }

  render() {
    return (
      <button
        onClick={this.onClick}
        className="next-button"
      >
        <div className="text">
          Neste
        </div>
      </button>
    );
  }
}

export default NextButton;
