/* eslint-disable react/forbid-prop-types */
import PropTypes from 'prop-types';
import React, { Component } from 'react';
import NumberPicker from '../../../common/NumberPicker.jsx';

class Counter extends Component {
  constructor(props) {
    super(props);
    this.change = this.change.bind(this);
  }

  change(count) {
    if (count > 0) {
      this.props.formActions.updateDataField(this.props.field, count);
    }
  }

  render() {
    return (
      <div className="number-picker options">
        <NumberPicker value={this.props.value} onChange={this.change} />
      </div>
    );
  }
}

if (__DEV__) {
  Counter.propTypes = {
    field: PropTypes.string.isRequired,
    formActions: PropTypes.object.isRequired,
    value: PropTypes.number.isRequired
  };
}

export default Counter;
