/* eslint-disable react/forbid-prop-types */
import PropTypes from 'prop-types';
import React, { Component } from 'react';
import NumberPicker from '../../../common/NumberPicker.jsx';
import { sheepColorPicerData } from '../../../constants/observation/sheepColors';

class SheepColor extends Component {
  constructor(props) {
    super(props);
    this.change = this.change.bind(this);
  }

  change(count, name) {
    const state = { ...this.props.value };
    state[name] = count;
    this.props.updateDataField(this.props.groupIndex, state);
  }

  render() {
    const colors = sheepColorPicerData.map(element => {
      return (
        <div className="color-container options" key={element.name}>
          <div className="text">{element.label}</div>
          <NumberPicker
            name={element.name}
            value={this.props.value[element.name]}
            onChange={this.change}
          />
        </div>
      );
    });

    return (
      <div className="color-panel">
        {colors}
      </div>
    );
  }
}

if (__DEV__) {
  SheepColor.propTypes = {
    groupIndex: PropTypes.number.isRequired,
    updateDataField: PropTypes.func.isRequired,
    value: PropTypes.object.isRequired
  };
}

export default SheepColor;
