/* eslint-disable react/require-default-props */
import PropTypes from 'prop-types';
import React, { Component } from 'react';

class TextField extends Component {
  constructor(props) {
    super(props);
    this.state = {
      value: this.props.value
    };
    this.onChange = this.onChange.bind(this);
    this.onBlur = this.onBlur.bind(this);
  }

  onChange(event) {
    this.setState({
      value: event.target.value
    });
  }

  onBlur() {
    this.props.updateDataField(this.props.field, this.state.value);
  }

  render() {
    return (
      <div className="description options">
        <textarea
          value={this.state.value}
          onChange={this.onChange}
          className="form-control"
          rows={this.props.rows}
          onBlur={this.onBlur}
        />
      </div>
    );
  }
}

TextField.defaultProps = {
  rows: 1,
  value: ''
};

if (__DEV__) {
  TextField.propTypes = {
    field: PropTypes.string.isRequired,
    rows: PropTypes.number,
    updateDataField: PropTypes.func.isRequired,
  };
}

export default TextField;
