import {
  UPDATE_ZOOM_LEVEL,
  UPDATE_OPEN_OBSERVATION_IDS,
  UPDATE_USER_POSITION
} from '../constants/mapActionTypes.js';

const initialState = {
  openObservationIds: {}, // **
  zoomLevel: 15, // **
  currentUserPosition: {}
};

export default function map(state = initialState, action) {
  switch (action.type) {

    case UPDATE_ZOOM_LEVEL:
      return {
        ...state,
        zoomLevel: action.zoomLevel
      };

    case UPDATE_OPEN_OBSERVATION_IDS:
      return {
        ...state,
        openObservationIds: action.observation
      };

    case UPDATE_USER_POSITION: {
      const currentUserPosition = {
        latitude: action.latitude,
        longitude: action.longitude
      };
      return {
        ...state,
        currentUserPosition
      };
    }

    default:
      return state;
  }
}
