import {
  ADD_ROUTE_TO_HISTORY,
  TOGGLE_NEW_OBSERVATION_VIEW,
  TOGGLE_NEW_OBSERVATION_ROUND_VIEW,
  TOGGLE_NAVIGATION_MENU_VIEW,
  TOGGLE_SAVED_ROUNDS_VIEW,
  TOGGLE_SETTINGS_VIEW,
  TOGGLE_FINISH_ROUND_VIEW
} from '../constants/actionTypes/routerActionTypes';

const initialState = {
  history: [],
  showNewObservationView: false,
  showNewObservationRoundView: false,
  showNavigationMenuView: false,
  showSavedRoundsView: false,
  showSettingsView: false,
  showFinishRoundView: false
};

export default function routerReducer(state = initialState, action) {
  switch (action.type) {
    case ADD_ROUTE_TO_HISTORY: {
      const history = [...state.history];
      history.push(action.route);
      return {
        ...state,
        history
      };
    }

    case TOGGLE_NEW_OBSERVATION_VIEW: {
      return {
        ...state,
        showNewObservationView: !state.showNewObservationView
      };
    }

    case TOGGLE_NEW_OBSERVATION_ROUND_VIEW: {
      return {
        ...state,
        showNewObservationRoundView: !state.showNewObservationRoundView
      };
    }

    case TOGGLE_NAVIGATION_MENU_VIEW: {
      return {
        ...state,
        showNavigationMenuView: !state.showNavigationMenuView
      };
    }

    case TOGGLE_SAVED_ROUNDS_VIEW: {
      return {
        ...state,
        showSavedRoundsView: !state.showSavedRoundsView
      };
    }

    case TOGGLE_SETTINGS_VIEW: {
      return {
        ...state,
        showSettingsView: !state.showSettingsView
      };
    }

    case TOGGLE_FINISH_ROUND_VIEW: {
      return {
        ...state,
        showFinishRoundView: !state.showFinishRoundView
      };
    }

    default:
      return state;
  }
}
