
import Velocity from 'velocity-animate';

export function animateRightToLeft(id, duration = 250) {
  const div = document.getElementById(id);
  Velocity(div, { left: 0 }, duration);
}

export function animateLeftToRight(id, duration = 250) {
  const div = document.getElementById(id);
  div.style.left = '-100vw';
  Velocity(div, { left: 0 }, { duration, ease: 'ease' });
}

export function animateToLeftPosition(id, position, method = () => { return 1; }, duration = 250) {
  const div = document.getElementById(id);
  Velocity(div, { left: position }, { duration, complete: () => method() });
}

export function fadeIn(id, duration = 100) {
  const div = document.getElementById(id);
  Velocity(div, { opacity: 1 }, { duration });
}