
const inDev = false;

export function openConfirmWindow(message, onYes, onNo = () => {}) {
  if (inDev) {
    if (window.confirm(message)) {
      onYes();
    } else {
      onNo();
    }
  } else {
    navigator.notification.confirm(
      message,
      buttonIndex => {
        if (buttonIndex === 1) {
          onYes();
        } else if (buttonIndex === 2) {
          onNo();
        }
      },
      'Advarsel',
      ['Ja', 'Nei']
    );
  }
}

export function openSuccessWindow(message) {
  if (inDev) {
    window.confirm(message);
  } else {
    navigator.notification.confirm(
      message,
      buttonIndex => {
        if (buttonIndex === 1) {}
      },
      'Suksess',
      ['Ok']
    );
  }
}

export function openWarningWindow(message) {
  if (inDev) {
    window.confirm(message);
  } else {
    navigator.notification.confirm(
      message,
      buttonIndex => {
        if (buttonIndex === 1) {

        }
      },
      'Advarsel',
      ['Ok']
    );
  }
}
