import React, {Component} from 'react';
import {Provider} from 'react-redux';
import {createStore, applyMiddleware} from 'redux'
import thunkMiddleware from 'redux-thunk';
import rootReducer from './reducers'

const store = createStore(
    rootReducer,
    applyMiddleware(
        thunkMiddleware
    )
);

class App extends Component {
    render() {
        return (

            <Provider store={store}>
                <div>
                    {this.props.children}
                </div>
            </Provider>
        );
    }
}

export default App;