import React, { Component } from 'react';
import {
    HashRouter as Router,
    Route,
    Link,
    Redirect,
    Switch,
} from 'react-router-dom'
import { connect } from 'react-redux';
import { bindActionCreators } from 'redux';

import * as authActions from './actions/authActions';

import Map from './containers/Map.jsx';
import ObservationRounds from './containers/ObservationRounds.jsx';
import Login from './containers/Login';
import Logout from './containers/Logout';
import SuccessFulLogin from './containers/SuccessFulLogin';
import NotFound from './containers/NotFound';
import Home from './containers/Home';
import Navbar from './containers/Navbar';
import Auth from './auth/Auth';
import { LOGIN_SUCCESS_URL, BASE_URL, HOME, LOGIN, LOGOUT, SUCCESSFUL_LOGIN, OBSERVATION_ROUNDS, MAP } from './constants/paths'

const auth = new Auth();


function handleAuthentication(nextState, historyPush) {
    //if (/access_token|id_token|error/.test(nextState.location.hash)) {
        console.log('yyy')
        auth.handleAuthentication(historyPush);
    // } else {
    //     console.error(' handle login failed ')
    //     //this.props.history.push(HOME);
    // }
};

function mustLogin() {
    console.log('is auth', auth.isAuthenticated())
    return  !auth.isAuthenticated(); // && this.props.location.hash === ''
}

function test(props) {
    console.log('wwwwwwwwwwwwwwwweeeeeeeeeeeeeeeeeeeeeeeEEEEEEEEEEEEE')
    console.log(props)
    let url = window.location.href;
    console.log('url with params:')
    console.log( url);

    //url = url.substring(0, url.indexOf('#'));
    const logincSuccessUrl = BASE_URL + SUCCESSFUL_LOGIN + '/';

    alert(url);
    alert(LOGIN_SUCCESS_URL);



    const historyPush = (location) => {
        props.history.push(location);
    };

    if  (auth.isAuthenticated()) {
        return true;
    } else if (url === 'http://sheep-website.s3-website.eu-central-1.amazonaws.com/#/!/login-success') {
        console.log('URL Match login')

        if (auth.isAuthenticated()) {
            // historyPush(HOME)
            console.log('push HOME')
        } else {
            console.log('start login')
            auth.handleAuthentication(historyPush);
        }

        return true;
    } else {
        console.log('return false')
        return false;
    }
}

const PrivateRoute = ({ component: Component, ...rest }) => (
  <Route
    {...rest}
    render={props =>
        test(props) ? (
              <div className="site-container">
                  <Navbar {...props}/>
                  <div className="content-container">
                      <Component {...props} />
                  </div>
              </div>
            ) : (
                <Redirect
                to={{
                  pathname: "/login",
                  state: { from: props.location }
                }}
              />
        )


      // auth.isAuthenticated() ? (
      //   <div className="site-container">
      //       <Navbar {...props}/>
      //       <div className="content-container">
      //           <Component {...props} />
      //       </div>
      //   </div>
      // ) : (
      //   <Redirect
      //     to={{
      //       pathname: "/login",
      //       state: { from: props.location }
      //     }}
      //   />
      // )
    }
  />
);


class AppRouter extends Component {
    constructor(props) {
        super(props);
        this.loadTokenFromLocalStorage();
    }

    loadTokenFromLocalStorage() {
        const token = localStorage['id_token'];
        const expireAt = localStorage['expires_at'];
        const currentTime = new Date().getTime();

        if (token === undefined || expireAt === undefined || expireAt < currentTime) {
            this.props.authActions.setAuth(null, false);
        } else {
            this.props.authActions.setAuth(token, true);
        }
    }

    logout(component) {
        auth.logout();
        return component;
    }

    render() {
        return (
            <Router>
                <Switch>
                    <PrivateRoute exact path={HOME} component={Home} />
                    <Route exact path={LOGIN} component={Login}/>
                    <Route exact path={LOGOUT} component={Logout} />
                    <Route exact path={SUCCESSFUL_LOGIN} component={SuccessFulLogin} />
                    <PrivateRoute exact path={MAP} component={Map} />
                    <PrivateRoute exact path={OBSERVATION_ROUNDS} component={ObservationRounds} />)}/>
                    <PrivateRoute component={NotFound}/>
                </Switch>
            </Router>
        );
    }
}

function stateToProps(state) {
    return { auth: state.auth };
}

function dispatchToProps(dispatch) {
    return {
        authActions: bindActionCreators(authActions, dispatch)
    };
}

export default connect(stateToProps, dispatchToProps)(AppRouter);
