import * as types from '../constants/actionTypes/observationRoundActionTypes';
import { API_OBSERVATION_ROUNDS } from '../constants/paths';
import { get } from '../actions/request';


export function fetchObservationRounds() {
    return dispatch => {
        dispatch(fetchStart());

        const onSuccess = response => {
            dispatch(setObservationRounds(response.data));
        };

        get(API_OBSERVATION_ROUNDS, onSuccess, fetchFailed);
    };
}
function setObservationRounds(observationRounds) {
    return {
        type: types.SET_OBSERVATION_ROUNDS,
        observationRounds
    };
}

function addObservationRound(observationRound) {
    return {
        type: types.ADD_OBSERVATION_ROUND,
        observationRound
    };
}

function fetchStart() {
    return {
        type: types.OBSERVATION_ROUND_FETCH_START,
    };
}

function fetchFailed() {
    console.error('OBSERVATION_ROUND_FETCH_FAILED action');
    return {
        type: types.OBSERVATION_ROUND_FETCH_FAILED,
    };
}