import axios from 'axios';
import Auth from './../auth/Auth';

const auth = new Auth();


export function get(path, onSuccess, onError) {
    const config = {
        headers: {
            Authorization: 'Bearer ' + localStorage['id_token']
        }
    };

    axios.get(path, config)
        .then(onSuccess)
        .catch(error => {
            if (error.response && error.response.status === 401) {
                auth.login();
            } else {
                onError();
            }
    });
}