import auth0 from 'auth0-js';
import { BASE_URL, HOME, SUCCESSFUL_LOGIN , LOGIN_SUCCESS_URL} from '../constants/paths';

const AWS_URI = 'http://sheep-website.s3-website.eu-central-1.amazonaws.com/login-success/';

export default class Auth {
    auth0 = new auth0.WebAuth({
        domain: 'sheep-app-api.eu.auth0.com',
        clientID: 'zQ6nlO3owVjj6-WcNcSEfjHu8xHz_EhX',
        redirectUri: LOGIN_SUCCESS_URL, // BASE_URL + SUCCESSFUL_LOGIN + '/',
        audience: 'https://sheep-app-api.eu.auth0.com/userinfo',
        responseType: 'token id_token',
        scope: 'openid'
    });

    constructor() {
        this.login = this.login.bind(this);
        this.logout = this.logout.bind(this);
        this.handleAuthentication = this.handleAuthentication.bind(this);
        this.isAuthenticated = this.isAuthenticated.bind(this);
    }

    handleAuthentication(historyPush, callback = () => {}) {
        console.log('enter handleAuthentication');
        this.auth0.parseHash((err, authResult) => {
            console.log('enter auth0.parsehash')
            console.log(authResult)
            if (authResult && authResult.accessToken && authResult.idToken) {
                console.log('inside hasthing - redirect home - its all goooodd!')
                this.setSession(authResult, callback);
                historyPush(HOME);
                window.history.pushState('page2', 'Title', '/');
            } else if (err) {
                console.error('handleAuthentication', err);
            }
        });
    }

    setSession(authResult, callback) {
        console.log('save session')
        // Set the time that the Access Token will expire at
        let expiresAt = JSON.stringify((authResult.expiresIn * 1000) + new Date().getTime());
        localStorage.setItem('access_token', authResult.accessToken);
        localStorage.setItem('id_token', authResult.idToken);
        localStorage.setItem('expires_at', expiresAt);
        // callback
        callback(authResult.idToken);

    }


    logout(callback = () => {}) {
        // Clear Access Token and ID Token from local storage
        localStorage.removeItem('access_token');
        localStorage.removeItem('id_token');
        localStorage.removeItem('expires_at');
        // Callback
        callback();
    }

    isAuthenticated() {
        // Check whether the current time is past the
        // Access Token's expiry time
        let expiresAt = JSON.parse(localStorage.getItem('expires_at'));
        return new Date().getTime() < expiresAt;
    }

    login() {
        this.auth0.authorize();
    }
}

