import React, {Component} from 'react';
import { connect } from 'react-redux';
import { bindActionCreators } from 'redux';
import * as authActions from '../actions/authActions';
import Auth from './../auth/Auth';
import { LOGIN } from '../constants/paths';

const auth = new Auth();

class Logout extends Component {
    componentWillMount() {
        console.log('comp login will mount, logout');
        auth.logout(this.props.authActions.logout);
        this.props.history.push(LOGIN);
    }

    render() {
        return (
            <div>
                Logout
            </div>
        );
    }
}

function stateToProps(state) {
    return { auth: state.auth };
}

function dispatchToProps(dispatch) {
    return {
        authActions: bindActionCreators(authActions, dispatch)
    };
}

export default connect(stateToProps, dispatchToProps)(Logout);