import React, {Component} from 'react';
import { connect } from 'react-redux';
import { bindActionCreators } from 'redux';
import * as authActions from '../actions/authActions';
import '../style/App.css';
import Auth from './../auth/Auth';
import { HOME } from './../constants/paths';

const auth = new Auth();

class SuccessFulLogin extends Component {
    componentWillMount() {
        const historyPush = (location) => {
            this.props.history.push(location);
        };
        if (this.mustLogin()) {
            historyPush(HOME)
        } else {
            this.handleAuthentication(this.props, historyPush);
        }
    }

    handleAuthentication(nextState, historyPush) {
        if (/access_token|id_token|error/.test(nextState.location.hash)) {
            auth.handleAuthentication(historyPush, this.props.authActions.login);
        } else {
            this.props.history.push(HOME);
        }
    };

    mustLogin() {
        return this.props.location.hash === '' && !auth.isAuthenticated();
    }

    render() {
        console.log('logged in!!!!!!!!')
        return (
            <div>
                login success
            </div>
        );
    }
}

function stateToProps(state) {
    return { auth: state.auth };
}

function dispatchToProps(dispatch) {
    return {
        authActions: bindActionCreators(authActions, dispatch)
    };
}

export default connect(stateToProps, dispatchToProps)(SuccessFulLogin);