import * as types from '../constants/actionTypes/authActionTypes';


const initialState = {
    token: null,
    loggedIn: false,
};

export default (state = initialState, action) => {
    switch (action.type) {
        case types.LOGIN:
            const token = action.token;
            const isValidToken = typeof token === 'string' && token.length > 0;
            return {
                token: isValidToken ? token : null,
                loggedIn: isValidToken
            };
        case types.LOGOUT:
            return {
                token: null,
                loggedIn: false
            };
        case types.SET_AUTH:
            return {
                token: action.token,
                loggedIn: action.loggedIn
            };
        default:
            return state
    }
};
