import * as types from '../constants/actionTypes/observationRoundActionTypes';


const initialState = {
    status: {
        fetching: false,
        errors: false,
    },
    data: []
};

export default (state = initialState, action) => {
    switch (action.type) {
        case types.OBSERVATION_ROUND_FETCH_START:
            return {
                ...state,
                status: {
                    fetching: true,
                    errors: false,
                },
            };

        case types.OBSERVATION_ROUND_FETCH_FAILED:
            return {
                ...state,
                status: {
                    fetching: false,
                    errors: true,
                },
            };

        case types.SET_OBSERVATION_ROUNDS: {
            const data = action.observationRounds;
            return {
                ...state,
                status: {
                    fetching: false,
                    errors: false,
                },
                data
            };
        }



        default:
            return state
    }
};
