import moment from 'moment';

const DAYS = ['Søndag', 'Mandag', 'Tirsdag', 'Onsdag', 'Torsdag', 'Fredag', 'Lørdag'];
const MONTHS = ['Januar', 'Februar', 'Mars', 'April', 'Mai', 'Juni', 'Juli', 'August', 'Septemper', 'Oktober', 'November', 'Desember'];

function getMonth(time) {
  return MONTHS[moment(time).month()];
}

function getDay(time) {
  return DAYS[moment(time).day()];
}

export function getDateTimeAsString(time) {
  const date = moment(time);
  const dateObject = {
    year: date.year(),
    month: getMonth(time),
    date: date.date(),
    day: getDay(time),
    hours: date.format('HH'),
    minutes: date.format('mm')
  };
  return `${dateObject.day} ${dateObject.date}. ${dateObject.month}, kl. ${dateObject.hours}:${dateObject.minutes}`;
}

export function getDateAsString(time) {
  const date = moment(time);
  const dateObject = {
    year: date.year(),
    month: getMonth(time),
    date: date.date(),
    day: getDay(time)
  };
  return `${dateObject.day} ${dateObject.date}. ${dateObject.month}`;
}

export function getTimeAsString(time) {
  const date = moment(time);
  const dateObject = {
    hours: date.format('HH'),
    minutes: date.format('mm')
  };
  return `${dateObject.hours}:${dateObject.minutes}`;
}